#!/usr/bin/perl -T
# $Id: about.cgi,v 1.7 2015/01/21 07:17:45 sofc Exp $
############################################################
############################################################
###                                                      ###
###   Originally designed by Karin Soeren Koch           ###
###                                                      ###
###   Impelemented by Soeren Koch                        ###
###                                                      ###
###   Copyright by Soeren Koch January 2005              ###
###                                                      ###
############################################################
############################################################

use strict;
use warnings;
use ElchemeaHeader;
use Elchemea;
use ElchemeaDevice;
use SemaforeFile;
use ElchemeaCGI qw(:DEFAULT :html :cgi);
use Eurotherm;
use CGI qw(:standard :netscape);
if (!defined(param))
{
    print_header("Please log in to the Elchemea");
    print '<center>';
    &ElchemeaCGI::login;
    print '</center>';
    &print_end;
}
else
{
    if (login_ok())
    { 
	print_header("About Elchemea");
	top_nav_bar_start();
	top_no_button();
	top_no_button();
	top_no_button();
	tab_newrow();
	js_back();
	top_js_return('#006600','white');
	top_no_button();
	top_no_button();
	top_no_button();
        top_nav_bar_button('main.cgi','','','To menu','s4');
	end_top_bar();
	param(-name=>'action',-value=>'') unless (param('action'));
	$_ = param('action');
      CASE:
	{
	    ### Insert case statements ###
	    ### Default response ####
	    &main_page;
	}
	print_end();
    }
    else 
    {
	not_auth();
    }
}
    
exit;



sub main_page
{
    my $file = SemaforeFile->new('/home/elchemea/build');
    my @l = $file->readlines;
    my $build = $l[0];
    print '<center>';
    print h1("About Elchemea ".$Elchemea::VERSION." build $build");
    print '<table border=0 style="width:100%;">';
    print '<tr height=1>';
    print '<td width="10%"></td>';
    print '<td width="25%"></td>';
    print '<td width="25%"></td>';
    print '<td width="25%"></td>';
    print '<td width="15%"></td>';
    print '</tr>';
    print '<tr><td></td><td colspan="3" class=about>';
    print "The Elchemea software was originally designed by ".$Elchemea::DESIGNERS;
    print '</td></tr>';
    print '<tr><td></td><td colspan="3" class=about>';
    print 'The Software is written in Perl&copy; and the graphics created by this software are created using Gnuplot&copy;';
    print '</td></tr>';
    print '<tr><td></td><td colspan="3" class=about>';
    print 'Impelemented by ',$Elchemea::IMPLEMENTERS;
    print '</td></tr>';
    print '<tr><td height=10></td></tr>';
    print '<tr><td></td><th> Elcctrochemical interfaces supported:</th><th> Frequency response analysers supported: </th><th> Furnace controlers supported: </th></tr>';
    print '<tr><td></td><th>',"\n";
    print join('<br>',(sort {$a cmp $b} grep (!/NONE/, ElchemeaDevice::get_PSTAT_list)));
    print '</th><th>',"\n";
    print join('<br>',(sort {$a cmp $b} grep (!/NONE/, ElchemeaDevice::get_FRA_list)));
    print '</th><th>',"\n";
    print join('<br>',(sort {$a cmp $b} Eurotherm::get_list));
    print '</th></td>';
    print '</table>';

    print '<p class="about" style="width:80%;">';
    print <<END;
    Copyright &copy S&oslash;ren Koch, Karin Vels Hansen and <a href="http://www.ecs.dtu.dk/">DTU Energy</a>

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.
<br>
    This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
<br>
    You should have received a copy of the GNU General Public License
    along with this program. If not, see <a href="http://www.gnu.org/licenses/">www.gnu.org/licenses/ </a>.



END

    print '</p></center>';
}
