#!/usr/bin/perl -T
# $Id: prelogin.cgi,v 1.12 2022/10/13 06:57:27 sqko Exp $
############################################################
############################################################
###                                                      ###
###   Originally designed by Soeren Koch                 ###
###                                                      ###
###   Impelemented by Soeren Koch                        ###
###                                                      ###
###   Copyright by Soeren Koch January 2005              ###
###                                                      ###
############################################################
############################################################

use strict;
use warnings;
use Elchemea;
use Sys::Hostname;
use ElchemeaCGI qw(:cgi :html);
use CGI qw(:standard :netscape);
use MIME::Base64;

print header();
print '<link rel="shortcut icon" href="/elchemea/Elchemea.ico">',"\n";
print start_html(-title=>'Elchemea '.$Elchemea::VERSION, -style=>{src=>'/elchemea/standard.css',src=>'/elchemea/Elchemea.css'});
print '<table  class=top_table>';
print '<col width=20%, span=5>';
print '<tr>';
print "\n";
create_menu_field();
print button(-name=>'Login',-value=>'Login',-class=>'s3',-onclick=>'windowOpen()');
print '</td>';
my $remote_url = get_config_value('global','sso_url');
if ($remote_url)
{
    print '<td>';
    my $url = 'https://'.hostname().'/cgi-bin/elchemea/main.cgi?dummy=1';
    my $str = encode_base64($url);
    if ($str)
    {
        $str =~ s/\n//g;
    }
    ### Add dummy parameter to awoid stripping end of true link by mail clients etc ###                                                  
    $str .= '&end=here';
    my $link = $url.'?dest='.$str;
    print start_form(-class=>"form",-action=>$remote_url.'?dest='.$str);
    print submit(-name=>'action',-value=>'SSO Login',-class=>'s3');
    print end_form;
    print '</td>';
}
else
{
    top_no_button();
}
&Localbutton('Create new user login','s3','new_user');
top_no_button();
if (defined(param('action')))
{
    &Localbutton('Home','s3');
}
else
{
    top_no_button();
}
tab_newrow();
top_no_button();
top_no_button();
top_no_button();
top_no_button();
top_no_button();
end_top_bar();

my $script = 'popup.html';
$script = 'popup_pwd.html' if (get_config_value('global','use_passwd') && get_config_value('global','use_passwd') =~ /yes/);

print "\n",'<script lanuage="javascript">',"\n";
print <<END;

function windowOpen() {
    var myWindow=window.open('../../elchemea/$script','windowRef','width=450,height=100,left=300,top=200');
    myWindow.location.href = '../../elchemea/$script';
    if (!myWindow.opener)
        myWindow.opener = self;
    myWindow.focus();
}

function go()
{
    document.login.action.click();
}
</script>
END



param(-name=>'action',-value=>'') unless (param('action'));
$_ = param('action');
 CASE:
{
    ### Insert case statements ###
    /^new_user$/ and do {&new_user_form; last CASE;};
    /^new_user_data$/ and do {&cusr; last CASE;};
    ### Default response ####
    &main_form;
}
print start_form(-name=>'login',-class=>"form",-action=>'login.cgi');
print hidden(-name=>'user',-value=>'',-force=>'1');
print hidden(-name=>'pass',-value=>'',-force=>'1');
print submit(-name=>'action',-value=>'Login',-class=>'hidden');
print end_form;
&print_end;
exit;


sub cusr
{
    my $nuser = '';
    my $nname = '';
    $nuser = param('nuser') if (defined(param('nuser')));
    $nuser =~ /(\w*)/;
    $nuser = lc($1);  ## Only accept lower case usernames's ###
    my $npass = '';
    $npass = param('npass') if (defined(param('npass')));
    $npass =~ /(\w*)/;
    if (Elchemea::user_exist($nuser))
    {
        print center(h3({-class=>'Alert'},"User already exsists!"));
    }
    else
    {
	if (length($nuser)>3)
	{
	    my $res = Elchemea::CGI_client('create_user',$nuser,$npass);
	    if ($res > 0)
	    {
		print center(h3({-class=>'Bl'},"User '$nuser' created"));
	    }
	    else
	    {
		print center(h3({-class=>'Bl'},"User Not created, error: $res"));
	    }
	}
	else
	{
	    print center(h3({-class=>'Alert'},"Username not 4 or more characters or"));
        }
    }
}


sub new_user_form
{
    print <<END;

<script lanuage="javascript">

function checkinput()
{
    var f = document.new_user;
    var txt = f.nuser.value;
    if (txt.length < 4) {
	alert("User name is not 4 or more letters!");
	return false;
    }
    return true;
}

</script>

END

    print start_form(-name=>'new_user',-onsubmit=>'return checkinput()');
    &action('new_user_data');
    print '<center>',"\n";
    print h3('Please provide the following information:');
    print '<table border=0 cellspacing=10 cellpadding=0>';
    print '<tr><th>';
    print p('Username');
    print '</th><th>';
    print textfield(-name=>'nuser',-value=>'',-force=>'1');
    print '</th></tr>';
    if (get_config_value('global','use_passwd') && get_config_value('global','use_passwd') =~ /yes/i && !get_config_value('global','password_wsdl'))
    {
	print '<tr><th>';
	print p('Password');
	print '</th><th>';
	print textfield(-name=>'npass',-value=>'',-force=>'1');
	print '</th></tr>';
	print '<tr><th>';
	print p('Repeat Password');
	print '</th><th>';
	print textfield(-name=>'npass2',-value=>'',-force=>'1',-onchange=>'checkpwd()');
	print '</th></tr>';

	print <<END

<script language="javascript">

function checkpwd()
{
    var pass1 = document.new_user.npass.value;
    var pass2 = document.new_user.npass2.value;
    if (pass1 == pass2)
    {
	return true;
    }
    alert("Passwords are not equal!")
    {
	document.new_user.npass.value = '';
	document.new_user.npass2.value = '';
	document.new_user.npass.focus;
	return false;
    }
}

</script>


END
	
    }
    print '</table>';
    print submit(-name=>'action',-value=>'Create user',-class=>'s4',-style=>'width:200px;');
    print '</center>';
    print end_form;
}

sub Localbutton($$)
{
    my $name = shift;
    my $class = shift;
    create_menu_field();
    my $cgname = $name;
    $cgname =~ s/\s+/_/g;
    print start_form(-name=>$cgname);
    if (@_)
    {
	my $action = shift;
	action($action);
    }
    print submit(-name=>$name,-class=>$class);
    while (@_)
    {
        my @s = split(/\,/,shift @_);
        print hidden(-name=>$s[0],-value=>$s[1],-force=>$s[2]);
    }
    print end_form;
    print '</td>';
}


sub main_form
{
    print '<center>';
    my $server = hostname;
    print h1("Elchemea ".$Elchemea::VERSION);
    print '<img name="splash" src="/elchemea/elchemea.png" id="splash">';
    print '</center>';
}
